function eidolon=disarray_image(image_matrix,REACH,NOISE_FILTER_STD,DISARRAY_MASK);


image_matrix=double(image_matrix);

IMSIZE=size(image_matrix);

sizeim=length(IMSIZE);
if ~any(sizeim==[2 3]);
    error('Image Must Be NxM or NxMx3');
end
if any(IMSIZE(1:2)<2)
    error('Image Must Be NxM or NxMx3 with both N and M lager than 1');
end



%%%% Define a few parameters


% color or grayscale image
if sizeim==3;
    NLAYERS=3;
else
    NLAYERS=1;
end



if nargin<2
    warning('Using Default Reach Value (image size/100)');
    REACH=max(IMSIZE/100);
end
if length(REACH)>1
    error('REACH must be SCALAR');
end

if nargin<3
    warning('Using Default NOISE_FILTER_STD (image size/100)');
    NOISE_FILTER_STD=max(IMSIZE/100);
end
if length(NOISE_FILTER_STD)>1
    error('NOISE_FILTER_STD must be SCALAR');
end



mask_disarray_field=0;
if ((nargin>=4)&(~isempty(DISARRAY_MASK)))
    if ((any(DISARRAY_MASK(:))>1) | (any(DISARRAY_MASK(:))<0))
        error('Disarray mask values need to be between 0 and 1');
    end
    if length(size(DISARRAY_MASK))>2
        error('DISARRAY_MASK should be NxM with as many rows and columns as image_matrix');
    elseif any(size(DISARRAY_MASK)~=IMSIZE(1:2))
        error('DISARRAY_MASK should be NxM with as many rows and columns as image_matrix');
    end
    mask_disarray_field=1;
end

disp('Setup Gaussian Kernels');
tic
GAUSS_KRNL_SPECT=Setup_Gaussian_Kernels(IMSIZE,NOISE_FILTER_STD);
disp(['Done ',num2str( toc),' s']);


disp('Setup disarray');
tic
RANDF=Setup_disarray_noscale(GAUSS_KRNL_SPECT,REACH);
disp(['Done ',num2str( toc),' s']);

if mask_disarray_field
    disp('Mask Disarray Field');
    tic    
    for coorxy=1:2
        RANDF(:,:,coorxy)=RANDF(:,:,coorxy).*DISARRAY_MASK;
    end    
    disp(['Done ',num2str( toc),' s']);
end

disp('Build eidolon');
tic
eidolon=Apply_Disarray_noscale(image_matrix,RANDF);
disp(['Done ',num2str( toc),' s']);


